#____________________________________________________________________________________
#
#    PersistentThreads (see README.txt for more information)
#    Copyright (C) 2002 Christoph Becker-Freyseng
#
#    This library is free software; you can redistribute it and/or
#    modify it under the terms of the GNU Lesser General Public
#    License as published by the Free Software Foundation; either
#    version 2.1 of the License, or (at your option) any later version.
#
#    This library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#    Lesser General Public License for more details.
#
#    You should have received a copy of the GNU Lesser General Public
#    License along with this library; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#
#    christoph@mmc-startup.com
#    http://www.beyond-thoughts.com
#    http://www.mmc-startup.com
#____________________________________________________________________________________
#


__doc__="""PersistentThreads product initialization"""
__version__='0.2.1'


usePersistentThreads= 1
uninstallPersistentThreads= 0
initTypePersistentThreads= usePersistentThreads


if initTypePersistentThreads==usePersistentThreads:
    try:  # Do the whole Product-Init in a try, so nothing can go wrong
	from PConstants import product_id
	import PPManager
##	from PersistentProcessor import PersistentProcessor
	import PTTools
	import StandardPPs
	
	import sys
	sys.stderr.write('PersistentThreads for Zope\n')
	
	def initialize(contextP):
	    if str(product_id)!=str(contextP._ProductContext__prod.id):
		import sys
		sys.stderr.write('PersistentThreads are not properly configured. See README.txt and PConstants.py .\n')
		raise 'PersistentThreads are not properly configured. See README.txt and PConstants.py .'
	    contextP.registerHelp()
	    contextP.registerHelpTitle('PersistentThreads')
	    
	    PTTools.initPermissions()
	
	    PPManager.PPManager(contextP._ProductContext__prod)  # Initialize PPManager(s)
	
	    try:
		import PThreadTool
		PThreadTool.initPThreadTool(contextP._ProductContext__prod)
	    except:
		import sys, traceback
		traceback.print_exc(file=sys.stderr)
    except:
	import sys, traceback
	traceback.print_exc(file=sys.stderr)
else:
    try:  # Do the whole Product-Init in a try, so nothing can go wrong
	from PConstants import product_id, ppHandler_action, pThreadTool_action
	import PPManager
##	from PersistentProcessor import PersistentProcessor
	import PTTools
	import StandardPPs
	
	
	def initialize(contextP):
	    import sys
	    sys.stderr.write('Uninstalling PersistentThreads ..')
	    if str(product_id)!=str(contextP._ProductContext__prod.id):
		sys.stderr.write('PersistentThreads are not properly configured. See README.txt and PConstants.py .\n')
		raise 'PersistentThreads are not properly configured. See README.txt and PConstants.py .'
	    
	    try:	# remove the ppHandler
		delattr(contextP._ProductContext__prod, ppHandler_action)
	    except:
		import sys, traceback
		traceback.print_exc(file=sys.stderr)
	    try:	# remove the PThreadTool
		delattr(contextP._ProductContext__prod, pThreadTool_action)
	    except:
		import sys, traceback
		traceback.print_exc(file=sys.stderr)
	    get_transaction().commit()
	    sys.stderr.write('. DONE\n')
    except:
	import sys, traceback
	traceback.print_exc(file=sys.stderr)






